/*
 * @Descripttion:
 * @version: 1
 * @Author: 蒋亚奇
 * @Date: 2019-08-14 17:06:43
 * @LastEditors: 蒋亚奇
 * @LastEditTime: 2019-08-14 17:52:04
 */
const Handlebars = require('handlebars')
const fs = require('fs')
const path = require('path')
const beautify = require('js-beautify').js_beautify
const apiTemplate = fs.readFileSync(path.join(__dirname, './template/api.hbs'), 'utf-8')
const methods = fs.readFileSync(path.join(__dirname, './template/methods.hbs'), 'utf-8')
const method = fs.readFileSync(path.join(__dirname, './template/method.hbs'), 'utf-8')
const filter = fs.readFileSync(path.join(__dirname, './template/filter.hbs'), 'utf-8')
Handlebars.registerPartial('methods', methods)
Handlebars.registerPartial('method', method)
Handlebars.registerPartial('filter', filter)
Handlebars.registerHelper('toLowerCase', function (word) {
  return word.toLowerCase()
})
Handlebars.registerHelper('brackets', function (word) {
  return `{${word}}`
})
Handlebars.registerHelper('brackets', function (word) {
  return `{${word}}`
})

const codeApi = function (data) {
  let template = Handlebars.compile(apiTemplate)(data)
  template = beautify(template, { indent_size: 2, max_preserve_newlines: -1 })
  return template
}

const codeFilter = function (data) {
  if (!data.enumerations || !data.enumerations.length) {
    return ''
  }
  let template = Handlebars.compile(filter)(data)
  template = beautify(template, { indent_size: 2, max_preserve_newlines: -1, end_with_newline: true })
  return template
}

module.exports.codeApi = codeApi
module.exports.codeFilter = codeFilter
